=== modified file 'NEWS'
--- NEWS	2010-01-20 16:31:24 +0000
+++ NEWS	2010-01-20 23:26:31 +0000
@@ -64,6 +64,10 @@
 * Better explain the --uncommitted option of merge.
   (Neil Martinsen-Burrell, #505088)
 
+* ``bzr diff`` will now use the epoch when it is unable to determine 
+  the timestamp of a file, if the revision it was introduced in is a
+  ghost. (Jelmer Vernooij, #295611)
+
 * ``bzr export dir`` now requests all file content as a record stream,
   rather than requsting the file content one file-at-a-time. This can make
   exporting over the network significantly faster (54min => 9min in one

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2009-12-03 07:36:17 +0000
+++ bzrlib/diff.py	2010-01-20 23:26:31 +0000
@@ -453,7 +453,10 @@
 
 def _patch_header_date(tree, file_id, path):
     """Returns a timestamp suitable for use in a patch header."""
-    mtime = tree.get_file_mtime(file_id, path)
+    try:
+        mtime = tree.get_file_mtime(file_id, path)
+    except errors.FileTimestampUnavailable:
+        mtime = 0
     return timestamp.format_patch_date(mtime)
 
 
@@ -747,7 +750,10 @@
             source.close()
         if not allow_write:
             osutils.make_readonly(full_path)
-        mtime = tree.get_file_mtime(file_id)
+        try:
+            mtime = tree.get_file_mtime(file_id)
+        except errors.FileTimestampUnavailable:
+            mtime = 0
         os.utime(full_path, (mtime, mtime))
         return full_path
 

